//+------------------------------------------------------------------+
//| Die Strke des Corrected Average (CA) besteht darin,             |
//| dass der aktuelle Wert der Zeitreihe einen von der momentanen    |
//| Volatilitt abhngigen Schwellenwert berschreiten muss,         |
//| damit der Filter steigt bzw. fllt, wodurch Fehlsignale          |
//| in trendschwachen Phasen vermieden werden.                       |
//| -A.Uhl-                                                          |
//+------------------------------------------------------------------+
#property copyright "A.Uhl,  RickD 2006, Alexander Piechotta, mladen"
#property link      "www.forex-tsd.com"
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_color4  LightSkyBlue
#property indicator_color5  LightSalmon
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  2
#property indicator_style5  2

extern string TimeFrame       = "Current time frame";
extern double T3Period     =  25;
extern int    T3Price      =  PRICE_CLOSE;
extern double T3Hot        =  0.7;
extern bool   T3Original   = false;
extern int    AdaptPeriod  =  25;
extern int    DeviationsPeriod = 25;
extern int    DeviationsMethod = MODE_SMA;
extern double MaEnvelopePct    =  0.15;

double MABuf[];
double CABuf[];
double CABufda[];
double CABufdb[];
double EnvUp[];
double EnvDn[];
double slope[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

int digit;
double point;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void init()
{       
   digit = MarketInfo(Symbol(),MODE_DIGITS);
   point = MarketInfo(Symbol(),MODE_POINT);
   if(digit==3 || digit==5) point*=10;
   
   IndicatorBuffers(7);
   SetIndexBuffer(0, CABuf);
   SetIndexBuffer(1, CABufda);
   SetIndexBuffer(2, CABufdb);
   SetIndexBuffer(3, EnvUp);
   SetIndexBuffer(4, EnvDn);
   SetIndexBuffer(5, MABuf);
   SetIndexBuffer(6, slope);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Corrected Average (CA) ("+T3Period+")");
}
void deinit(){}  

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void start() 
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;   
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { CABuf[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (timeFrame != Period())
   {
      if (slope[limit] == -1) CleanPoint(limit,CABufda,CABufdb);
      for (i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Price,T3Hot,T3Original,AdaptPeriod,DeviationsPeriod,DeviationsMethod,MaEnvelopePct,6,y);
            CABuf[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Price,T3Hot,T3Original,AdaptPeriod,DeviationsPeriod,DeviationsMethod,MaEnvelopePct,0,y);
            EnvUp[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Price,T3Hot,T3Original,AdaptPeriod,DeviationsPeriod,DeviationsMethod,MaEnvelopePct,3,y);
            EnvDn[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Price,T3Hot,T3Original,AdaptPeriod,DeviationsPeriod,DeviationsMethod,MaEnvelopePct,4,y);
            CABufda[i] = EMPTY_VALUE;
            CABufdb[i] = EMPTY_VALUE;
            if (slope[i]==-1) PlotPoint(i,CABufda,CABufdb,CABuf);
      }
      return(0);  
   }        
   
   //
   //
   //
   //
   //
   //
   
   for ( i=limit; i >= 0; i--)
   {
      double dev = iStdDev(NULL,0,AdaptPeriod,0,MODE_SMA,T3Price,i);
      double avg = iSma(dev,AdaptPeriod,i,0);
         if (dev!=0) 
                double period = T3Period*avg/dev;
         else          period = T3Period; 
         if (period<3) period = 3;
  
  
         MABuf[i] = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),period,T3Hot,T3Original,i,0);
    
         if (i == Bars-1) { CABuf[i] = MABuf[i]; continue;}
         double v1 = MathPow(iStdDev(NULL, 0, DeviationsPeriod,0, DeviationsMethod, T3Price, i), 2);
         double v2 = MathPow(CABuf[i+1] - MABuf[i], 2);
         double k  = 0;
         if (v2 < v1 || v2 == 0) k = 0; else k = 1 - v1/v2;
      
         CABuf[i]   = CABuf[i+1] + k*(MABuf[i]-CABuf[i+1]);
         
         CABufda[i] = EMPTY_VALUE;
         CABufdb[i] = EMPTY_VALUE;
         EnvUp[i]   = EMPTY_VALUE;
         EnvDn[i]   = EMPTY_VALUE;
         
         slope[i]   = slope[i+1];
            if (CABuf[i]>CABuf[i+1]) slope[i] =  1;
            if (CABuf[i]<CABuf[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,CABufda,CABufdb,CABuf);

         if(MathAbs(CABuf[i]-CABuf[i+1]) <= point)   //condition of OffTrend - ma stay in average pip spread
            {
               EnvUp[i] = CABuf[i]*(1+MaEnvelopePct/100);
               EnvDn[i] = CABuf[i]*(1-MaEnvelopePct/100);
            }
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workSma[][2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}